<?php

namespace Teknisa\CADEST\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\CADEST\Services\Ger10000SegmentoDeMercadoService;


class Ger10000SegmentoDeMercadoController extends \Teknisa\CADEST\Controllers\TeknisaCrud {
	protected $dataSourceName;
    protected $service;
     
    public function __construct($crudService, ParameterBag $parameterBag, $service) {
        $this->service = $service;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function saveProdutosSegmento(DTO\Request $request, DTO\Response $response) {
        try{
            $row = $request->getRow();
            $this->service->saveProdutosSegmento($row);
        }
        catch(\Exception $e) {
            $response->setError(new Error("Erro ao salvar os dados. ".$e->getMessage(), 500));
        }
        
        // try {
        //     #validates product insertion
        //     $valid = $this->service->validateProductInsertion($CDPRODUTO, $CDARVPROD, $IDCURVAABC, $CDALMOXARIFE, $CDLOCALESTOQ, $CDFILIAL, $NRORG);

        //     #returns validation
        //     $response->addDataSet(new DataSet("paramestoque_produto_validation", array($valid)));
        // } catch(\Exception $e) {
        //     #catches error and sets message as needed
        //     $response->setError(new Error("Erro ao salvar os dados. ".$e->getMessage(), 500));
        // }
        
    }
    
    public function deleteProdutosSegmento(DTO\Request $request, DTO\Response $response) {
        try{
            $row = $request->getRow();
            $this->service->deleteProdutosSegmento($row);
        }
        catch(\Exception $e) {
            throw $e;
        }
    }
    
}